
#include "spilcd.h"
#include "debug.h"

/****************************************************************************
*     ƣSPI2_Init(void)
*     ܣCH32_SPI2Ӳóʼ
* ڲ
* ڲ
* ˵    CH32_SPI2Ӳóʼ
****************************************************************************/
void SPI2_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    SPI_InitTypeDef  SPI_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_AFIO, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2 ,ENABLE);

    //SPI2ܽ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_14;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_10| GPIO_Pin_11| GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    //SPI2ѡ
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI2, &SPI_InitStructure);

    //ʹSPI2
    SPI_Cmd(SPI2, ENABLE);
}

/****************************************************************************
*     ƣu8 SPI_WriteByte(SPI_TypeDef* SPIx,u8 Byte)
*     ܣӲSPIдһֽݵײ㺯
* ڲSPIx,Byte
* ڲյ
* ˵    ӲSPIдһֽݵײ㺯
****************************************************************************/
u8 SPI_WriteByte(SPI_TypeDef* SPIx,u8 Byte)
{
    while((SPIx->STATR&SPI_I2S_FLAG_TXE)==RESET);    //ȴ
    SPIx->DATAR=Byte;                                //һbyte
    while((SPIx->STATR&SPI_I2S_FLAG_RXNE)==RESET);   //ȴһbyte
    return SPIx->DATAR;                              //յ
}

/****************************************************************************
*     ƣvoid SPI_SetSpeed(SPI_TypeDef* SPIx,u8 SpeedSet)
*     ܣSPIٶ
* ڲSPIx,SpeedSet
* ڲ
* ˵    SpeedSet:1,;0,;
****************************************************************************/
void SPI_SetSpeed(SPI_TypeDef* SPIx,u8 SpeedSet)
{
    SPIx->CTLR1&=0XFFC7;
    if(SpeedSet==1)//
    {
        SPIx->CTLR1|=SPI_BaudRatePrescaler_2;//Fsck=Fpclk/2
    }
    else//
    {
        SPIx->CTLR1|=SPI_BaudRatePrescaler_32; //Fsck=Fpclk/32
    }
    SPIx->CTLR1|=1<<6; //SPI豸ʹ
}

/****************************************************************************
*     ƣLcd_WriteIndex(u8 Index)
*     ܣҺдһ8λָ
* ڲIndex   Ĵַ
* ڲ
* ˵    ǰѡпڲ
****************************************************************************/
void Lcd_WriteIndex(u8 Index)
{
   LCD_CS_CLR;
   LCD_DC_CLR;
   SPI_WriteByte(SPI2,Index);
   LCD_CS_SET;
}

/****************************************************************************
*     ƣLcd_WriteData(u8 Data)
*     ܣҺдһ8λ
* ڲdat     Ĵ
* ڲ
* ˵    ַָдݣڲ
****************************************************************************/
void Lcd_WriteData(u8 Data)
{
   LCD_CS_CLR;
   LCD_DC_SET;
   SPI_WriteByte(SPI2,Data);
   LCD_CS_SET;
}

/****************************************************************************
*     ƣvoid LCD_WriteReg(u8 Index,u16 Data)
*     ܣдĴ
* ڲIndex,Data
* ڲ
* ˵    ΪϺIndexַļĴдDataֵ
****************************************************************************/
void Lcd_WriteReg(u8 Index,u16 Data)
{
    Lcd_WriteIndex(Index);
    Lcd_WriteData_16Bit(Data);
}

/****************************************************************************
*     ƣvoid Lcd_WriteData_16Bit(u16 Data)
*     ܣҺдһ16λ
* ڲData
* ڲ
* ˵    ַָдһ16λ
****************************************************************************/
void Lcd_WriteData_16Bit(u16 Data)
{
    Lcd_WriteData(Data>>8);
    Lcd_WriteData(Data);
}

/****************************************************************************
*     ƣvoid Lcd_Reset(void)
*     ܣҺӲλ
* ڲ
* ڲ
* ˵    Һʼǰִһθλ
****************************************************************************/
void Lcd_Reset(void)
{
    LCD_RESET_CLR;
    Delay_Ms(100);
    LCD_RESET_SET;
    Delay_Ms(50);
}
/****************************************************************************
*     ƣvoid Lcd_Init(void)
*     ܣҺʼ
* ڲ
* ڲ
* ˵    Һʼ_ILI9225_176X220
****************************************************************************/
void Lcd_Init(void)
{

    SPI2_Init();
    Lcd_Reset(); //Reset before LCD Init.

    //2.2inch TM2.2-G2.2 Init 20171020
    Lcd_WriteIndex(0x11);
    Lcd_WriteData(0x00);

    Lcd_WriteIndex(0xCF);
    Lcd_WriteData(0X00);
    Lcd_WriteData(0XC1);
    Lcd_WriteData(0X30);

    Lcd_WriteIndex(0xED);
    Lcd_WriteData(0X64);
    Lcd_WriteData(0X03);
    Lcd_WriteData(0X12);
    Lcd_WriteData(0X81);

    Lcd_WriteIndex(0xE8);
    Lcd_WriteData(0X85);
    Lcd_WriteData(0X11);
    Lcd_WriteData(0X78);

    Lcd_WriteIndex(0xF6);
    Lcd_WriteData(0X01);
    Lcd_WriteData(0X30);
    Lcd_WriteData(0X00);

    Lcd_WriteIndex(0xCB);
    Lcd_WriteData(0X39);
    Lcd_WriteData(0X2C);
    Lcd_WriteData(0X00);
    Lcd_WriteData(0X34);
    Lcd_WriteData(0X05);

    Lcd_WriteIndex(0xF7);
    Lcd_WriteData(0X20);

    Lcd_WriteIndex(0xEA);
    Lcd_WriteData(0X00);
    Lcd_WriteData(0X00);

    Lcd_WriteIndex(0xC0);
    Lcd_WriteData(0X20);

    Lcd_WriteIndex(0xC1);
    Lcd_WriteData(0X11);

    Lcd_WriteIndex(0xC5);
    Lcd_WriteData(0X31);
    Lcd_WriteData(0X3C);

    Lcd_WriteIndex(0xC7);
    Lcd_WriteData(0XA9);

    Lcd_WriteIndex(0x3A);
    Lcd_WriteData(0X55);

  Lcd_WriteIndex(0x36);
    #if USE_HORIZONTAL
         Lcd_WriteData(0xE8);//
    #else
         Lcd_WriteData(0x48);//
    #endif

    Lcd_WriteIndex(0xB1);
    Lcd_WriteData(0X00);
    Lcd_WriteData(0X18);

    Lcd_WriteIndex(0xB4);
    Lcd_WriteData(0X00);
    Lcd_WriteData(0X00);

    Lcd_WriteIndex(0xF2);
    Lcd_WriteData(0X00);

    Lcd_WriteIndex(0x26);
    Lcd_WriteData(0X01);

    Lcd_WriteIndex(0xE0);
    Lcd_WriteData(0X0F);
    Lcd_WriteData(0X17);
    Lcd_WriteData(0X14);
    Lcd_WriteData(0X09);
    Lcd_WriteData(0X0C);
    Lcd_WriteData(0X06);
    Lcd_WriteData(0X43);
    Lcd_WriteData(0X75);
    Lcd_WriteData(0X36);
    Lcd_WriteData(0X08);
    Lcd_WriteData(0X13);
    Lcd_WriteData(0X05);
    Lcd_WriteData(0X10);
    Lcd_WriteData(0X0B);
    Lcd_WriteData(0X08);

    Lcd_WriteIndex(0xE1);
    Lcd_WriteData(0X00);
    Lcd_WriteData(0X1F);
    Lcd_WriteData(0X23);
    Lcd_WriteData(0X03);
    Lcd_WriteData(0X0E);
    Lcd_WriteData(0X04);
    Lcd_WriteData(0X39);
    Lcd_WriteData(0X25);
    Lcd_WriteData(0X4D);
    Lcd_WriteData(0X06);
    Lcd_WriteData(0X0D);
    Lcd_WriteData(0X0B);
    Lcd_WriteData(0X33);
    Lcd_WriteData(0X37);
    Lcd_WriteData(0X0F);

    Lcd_WriteIndex(0x29);
}

/*************************************************
LCD_Set_XY
ܣlcdʾʼ
ڲxy
ֵ
*************************************************/
void Lcd_SetXY(u16 Xpos, u16 Ypos)
{
    Lcd_WriteIndex(0x2A);
    Lcd_WriteData_16Bit(Xpos);
    Lcd_WriteIndex(0x2B);
    Lcd_WriteData_16Bit(Ypos);
    Lcd_WriteIndex(0x2c);
}

/*************************************************
LCD_Set_Region
ܣlcdʾڴдԶ
ڲxyյ
ֵ
*************************************************/
//ʾ
void Lcd_SetRegion(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
{
    Lcd_WriteIndex(0x2A);
    Lcd_WriteData_16Bit(xStar);
    Lcd_WriteData_16Bit(xEnd);
    Lcd_WriteIndex(0x2B);
    Lcd_WriteData_16Bit(yStar);
    Lcd_WriteData_16Bit(yEnd);
    Lcd_WriteIndex(0x2c);
}

/*************************************************
LCD_DrawPoint
ܣһ
ڲxyɫ
ֵ
*************************************************/
void Gui_DrawPoint(u16 x,u16 y,u16 Data)
{
    Lcd_SetXY(x,y);
    Lcd_WriteData_16Bit(Data);
}

/*************************************************
Lcd_Clear
ܣȫ
ڲɫCOLOR
ֵ
*************************************************/
void Lcd_Clear(u16 Color)
{
   unsigned int i;
   Lcd_SetRegion(0,0,X_MAX_PIXEL-1,Y_MAX_PIXEL-1);
   LCD_CS_CLR;
   LCD_DC_SET;
   for(i=0;i<X_MAX_PIXEL*Y_MAX_PIXEL;i++)
   {
        //Lcd_WriteData_16Bit(Color);
        SPI_WriteByte(SPI2,Color>>8);
        SPI_WriteByte(SPI2,Color);

   }
   LCD_CS_SET;
}

